// 非居门牌幢列表
<template>
  <div class="routerWapper">
    <div v-if="$route.name == 'nonBuildingList'&&$permission('000201')" >
      <div class="portalDetailContentWapper">
        <div class="portalDetailTitle">
          <span class="title">{{$route.query.stName}} 门牌幢</span>
          <div class="detailOperations">
            <a-button @click="handleReturn"> 返回 </a-button>
          </div>
        </div>
      </div>
      <div class="layoutMargin layoutPadding">
        <a-form :form="form" class="protalForm" >
          <a-row class="formItemLine" type="flex" align='top' :gutter="18">
            <a-col span="8">
              <a-form-item label="门牌地址" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
                <a-input placeholder="请输入查询内容" v-decorator="['unitAddr_l']" />
              </a-form-item>
            </a-col>
            <template v-if="customKeyEnable">
              <a-col span="8"  v-for="i in searchList" :key="i.id" >
                <a-form-item :label="i.keyName" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
                  <a-select @change="handleChangeZdy(i.keyCode,$event)" v-if="i.compntType == 'select' || i.compntType == 'radio'" showSearch allowClear placeholder="请选择查询内容" v-decorator="[i.keyCode]">
                    <a-select-option v-for="(item) in JSON.parse(i.sltJson)" :key="item" :value="item">{{ item }}</a-select-option>
                  </a-select>
                  <a-select @change="handleChangeZdy(i.keyCode,$event)" mode="multiple" v-else-if="i.compntType =='checkbox'"  placeholder="请选择查询内容(多选)" v-decorator="[i.keyCode]">
                    <a-select-option v-for="(item) in JSON.parse(i.sltJson)" :key="item" :value="item">{{ item }}</a-select-option>
                  </a-select>
                  <a-date-picker @change="handleChangeZdy(i.keyCode,$event)" v-else-if="i.compntType =='date'"  v-decorator="[i.keyCode]"  />
                  <a-input v-else-if="i.compntType =='num'" type="tel" placeholder="请输入查询内容" v-decorator="[i.keyCode]" />
                  <a-input v-else placeholder="请输入查询内容" v-decorator="[i.keyCode]" />
                </a-form-item>
              </a-col>
            </template>
            <a-col span="24" class="algin-right">
              <!-- <a-button  @click="exportList">导出数据</a-button> -->
              <a-button @click="reset">重置</a-button>
              <a-button type="primary" @click="search">搜索</a-button>
            </a-col>
          </a-row>
        </a-form>
        <!-- <p class="gayLine noline" /> -->
        <div class="portalTableOperates">
          <tableAndMut ref="childTab" :tableData="tableData" :pagination="pagination" :tbl="tbl" />
        </div>
      </div>
    </div>
    <RouterWapper v-else />
  </div>
</template>

<script>
export default {
  name: 'nonBuildingList',
  data() {
    return {
      customKeyEnable: false, // cookie里存的是否开启自定义字段
      tbl: 'tbl_non_resident_building', // 当前表名,
      searchList: [], // 动态渲染的搜索列表
      keyCodeList: [], // 动态搜索的keycode列表
      searchParams: {}, //搜索的列表
      searchForm: {},
      columns: [ // 表格展示的列
        {
          title: '门牌幢地址',
          dataIndex: 'unitAddr',
          key: 'unitAddr',
          width: '40%'
        },
        {
          title: '建筑类型',
          dataIndex: 'unitBulidType',
          key: 'unitBulidType',
          width: '15%',
        },
        {
          title: '操作',
          dataIndex: 'action',
          key: 'action',
          width: '20%',
          scopedSlots: {
            customRender: 'action'
          }
        }
      ],
      pagination: { // 分页信息
        pageNo: 1,
        pageSize: 20,
        total: 0,
        current: 1,
        defaultCurrent: 1,
        defaultPageSize: 20,
        showQuickJumper: true,
        onChange: this.pageChange,
        showSizeChanger: true,
        showTotal: total => `总条数: ${total}`,
        onShowSizeChange: this.showSizeChange,
        pageSizeOptions: ['10', '20', '50', '100'],
      },
      tableData: [],
    }
  },
  beforeCreate() { // 页面进来创建form
    this.form = this.$form.createForm(this)
  },
  created () { // 进页面获取数据
    this.customKeyEnable=this.$cookie.get('customKeyEnable')
    if(this.customKeyEnable && this.customKeyEnable == 'true'){
      // this.getKeys()
      // this.getAllKeys()
    }else {
      this.getList()
    }
  },
  mounted(){
    if (this.$route.name == 'nonBuildingList') {
      this.$nextTick(function () {
        this.getSearchParams()
      })
    }
  },
  methods: {
    handleChangeZdy(i, e){ // 自定义字段 - 搜索条件的 change
      if (Object.prototype.toString.call(e)== '[object Array]') {
        e2 = e.join(',')
      } else if (Object.prototype.toString.call(e)== '[object Object]') {
        e2 = this.$moment(e).format('YYYY-MM-DD')
      }
      this.form.setFieldsValue({ // 传入的i 是i.keyCode   将form表单设置成最新的值
        i: e2
      })
      setTimeout(() => { // 延时器,去掉会拿不到最新的value
        this.getList()
      }, 0)
    },
    pageChange(page){ //分页切换
      this.pagination.pageNo = page
      this.pagination.current = page
      this.getList()
    },
    showSizeChange(current, size) { //每页条数切换
      this.pagination.pageNo = 1
      this.pagination.current = 1
      this.pagination.pageSize = size
      this.getList()
    },
    reset(){ // 重置表单
      this.form.resetFields()
      this.pagination.pageNo = 1
      this.pagination.current = 1
      this.pagination.pageSize = 20
      this.getList()
    },
    search() { // 搜索按钮
      this.pagination.current = 1
      this.pagination.pageNo = 1
      //需要发送ajax
      this.getList()
    },
    handleReturn(){ // 返回按钮
      this.$router.back()
    },
    getList(){ // 获取数据
      //处理动态的搜索条件,耦合到搜索列表
      const obj = {}
      this.keyCodeList.forEach(item => {
        let value = !this.form.getFieldValue(item)? '':this.form.getFieldValue(item)
        if (Object.prototype.toString.call(value)== '[object Array]') { //如果是数组
          value = value.join(',')
        }else if(Object.prototype.toString.call(value) === '[object Object]'){
          value = this.$moment(value).format('YYYY-MM-DD')
        }
        this.$set(obj, item, value)
      })

      const searchParams = Object.assign({}, {
        'unitAddr_l': !this.form.getFieldValue('unitAddr_l')?'':this.form.getFieldValue('unitAddr_l'),
        nrStId: this.$route.query.nrStId
      }, obj)
      this.searchParams = searchParams
      this.$ajax.get({
        url: this.$api.GET_NONBUILDING_LIST,
        params: Object.assign({}, searchParams, {
          pageSize: this.pagination.pageSize,
          pageNo: this.pagination.current,
        })
      }).then(res => {
        if (res.code === '200') {
          /**
           *      在请求数据的成功的时候   保存请求的各项数据及token   后面下载用
           */
          searchParams.token = this.$cookie.get('token')
          let a = this.tbl + '?'
          for(const k in searchParams){
            a = a+k+'='+ searchParams[k]+ '&'
          }
          this.exportParams = a
          this.pagination.total= this.$com.confirm(res, 'data.totalRows', 0)
          this.tableData = this.$com.confirm(res, 'data.content', [])
          this.tableData.forEach(col => {
            if (col.unitBulidType == 1) {
              col.unitBulidType = '低层'
            } else if (col.unitBulidType == 2){
              col.unitBulidType = '多层'
            } else if (col.unitBulidType == 3){
              col.unitBulidType = '高层'
            } else if (col.unitBulidType == 4){
              col.unitBulidType = '超高层'
            } 
            if (col.unitArchstruct == '01') {
              col.unitArchstruct = '含钢结构'
            } else if (col.unitArchstruct == '02'){
              col.unitArchstruct = '钢混结构'
            } else if (col.unitArchstruct == '03'){
              col.unitArchstruct = '砖混结构'
            } else if (col.unitArchstruct == '04'){
              col.unitArchstruct = '砖木结构'
            } else if (col.unitArchstruct == '05'){
              col.unitArchstruct = '木结构'
            } else if (col.unitArchstruct == '06'){
              col.unitArchstruct = '钢结构'
            } else if (col.unitArchstruct == '09'){
              col.unitArchstruct = '其他'
            }   
            if (col.unitFacadeType == 1) {
              col.unitFacadeType = '玻璃幕墙'
            } else if (col.unitFacadeType == 2){
              col.unitFacadeType = '外墙保温材料'
            } else if (col.unitFacadeType == 9){
              col.unitFacadeType = '其他'
            }  
            if (col.unitCnstAreaType == 1) {
              col.unitCnstAreaType = '实测面积'
            } else if (col.unitCnstAreaType == 2){
              col.unitCnstAreaType = '预估面积'
            }
            if (col.unitUngType == '01') {
              col.unitUngType = '商城'
            } else if (col.unitUngType == '02'){
              col.unitUngType = '车库'
            } else if (col.unitUngType == '09'){
              col.unitUngType = '其他'
            }
            if (col.unitExternalWallFlag == 0) {
              col.unitExternalWallFlag = '无'
            } else if (col.unitExternalWallFlag == 1){
              col.unitExternalWallFlag = '有'
            }
            if (col.unitFlag == false) {
              col.unitFlag = '无'
            } else {
              col.unitFlag = '有'
            }
          })
        }
        //
        // 存储当前页面列表的搜索信息
        //
        this.$com.storeSearchParams(
          this.$route.name,
          this.pagination,
          searchParams
        )
      })
    },
    /**
     * 从vuex中或已存储的搜索条件，判断此条件是否为当前路由的 。如果是则使用
     */
    getSearchParams(){
      const searchParams = !this.$store.state.listSearchParams?null:this.$store.state.listSearchParams[this.$route.name]
      if(!!searchParams && !!searchParams.routeName && (this.$route.name == searchParams.routeName)){
        if(!!searchParams.params){
          Object.keys(searchParams.params).forEach(elem => {
            switch (elem) {
            case 'unitAddr_l':
              this.form.setFieldsValue({ 'unitAddr_l': searchParams.params[elem] })
              break
            default:
              break
            }
          })
        }
        if(!!searchParams.pagination){
          if(!!searchParams.pagination.pageNo){
            this.pagination.pageNo = searchParams.pagination.pageNo
            this.pagination.current = searchParams.pagination.current
            this.pagination.pageSize = searchParams.pagination.pageSize
          }
        }
      }
      this.getList()
    },
    toView(params){ // 操作里面去详情
      this.$router.push({path: `/houseData/nonBuildingList/nonBuildingInfo/${params.id}`})
    },
    exportList(){ //导出功能
      const formValue = this.form.getFieldsValue()
      let newUrl = this.tbl + '?'
      let newObj = {}
      //拼接除 c.xxx 之外的数据
      for(const k in formValue){
        if (formValue[k]!= undefined ) { // 判断是否值为 undefined
          if ( k == 'c') { // 排除 c.xxx 的键
            newObj = formValue[k] //有c.xx存入 b对象  下面处理,
          } else if(Object.prototype.toString.call(formValue[k])== '[object Array]'){
            // 数组的话就拼接字符串
            newUrl += k +'=' + formValue[k].join(',') + '&'
          }else if (Object.prototype.toString.call(formValue[k]) === '[object Object]') {
            //时间格式对象就转换成字符串
            newUrl += k +'=' +this.$moment(formValue[k]).format('YYYY-MM-DD') +'&'
          }else {
            newUrl += k +'=' +formValue[k] +'&' //没有特殊情况  直接拼接到 newUrl
          }
        }
      }
      // 处理 c.xxx 里面的数据
      for(const k in newObj ){
        if (newObj[k] != undefined) { // 排除值为undefined的键
          newUrl += 'c.'+ k +'=' +newObj[k].split('#')[1] +'&' // 拼接到 newUrl
        }
      }
      const token = this.$cookie.get('token') // 获取token 并拼接到 newUrl
      newUrl += '&access_token=' + token.split('bearer ')[1] 
      window.open (this.$api.BASE_URL+'/service-basicdatasync-ddd/export/'+ newUrl)
    },
  },
}
</script>

<style>
.routerWapper[data-v-5f2c575d] .ant-table-small>.ant-table-content>.ant-table-body {
  margin: 0;
}
</style>
